/* AUTOGENERATED FILE. DO NOT EDIT. */
#include <string.h>
#include <stdlib.h>
#include <setjmp.h>
#include "cmock.h"
#include "mock_uart_driver.h"

static const char* CMockString_baudrate = "baudrate";
static const char* CMockString_byte = "byte";
static const char* CMockString_config_hardware = "config_hardware";
static const char* CMockString_uart_receive_char = "uart_receive_char";
static const char* CMockString_uart_send_char = "uart_send_char";

typedef struct _CMOCK_config_hardware_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  uint32_t Expected_baudrate;
  char IgnoreArg_baudrate;

} CMOCK_config_hardware_CALL_INSTANCE;

typedef struct _CMOCK_uart_receive_char_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  char ReturnVal;

} CMOCK_uart_receive_char_CALL_INSTANCE;

typedef struct _CMOCK_uart_send_char_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  char Expected_byte;
  char IgnoreArg_byte;

} CMOCK_uart_send_char_CALL_INSTANCE;

static struct mock_uart_driverInstance
{
  char config_hardware_IgnoreBool;
  char config_hardware_CallbackBool;
  CMOCK_config_hardware_CALLBACK config_hardware_CallbackFunctionPointer;
  int config_hardware_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE config_hardware_CallInstance;
  char uart_receive_char_IgnoreBool;
  char uart_receive_char_FinalReturn;
  char uart_receive_char_CallbackBool;
  CMOCK_uart_receive_char_CALLBACK uart_receive_char_CallbackFunctionPointer;
  int uart_receive_char_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE uart_receive_char_CallInstance;
  char uart_send_char_IgnoreBool;
  char uart_send_char_CallbackBool;
  CMOCK_uart_send_char_CALLBACK uart_send_char_CallbackFunctionPointer;
  int uart_send_char_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE uart_send_char_CallInstance;
} Mock;

extern jmp_buf AbortFrame;

void mock_uart_driver_Verify(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_MEM_INDEX_TYPE call_instance;
  call_instance = Mock.config_hardware_CallInstance;
  if (Mock.config_hardware_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_config_hardware);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.config_hardware_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
  call_instance = Mock.uart_receive_char_CallInstance;
  if (Mock.uart_receive_char_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_uart_receive_char);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.uart_receive_char_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
  call_instance = Mock.uart_send_char_CallInstance;
  if (Mock.uart_send_char_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_uart_send_char);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.uart_send_char_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
}

void mock_uart_driver_Init(void)
{
  mock_uart_driver_Destroy();
}

void mock_uart_driver_Destroy(void)
{
  CMock_Guts_MemFreeAll();
  memset(&Mock, 0, sizeof(Mock));
}

void config_hardware(uint32_t baudrate)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_config_hardware_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_config_hardware);
  cmock_call_instance = (CMOCK_config_hardware_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.config_hardware_CallInstance);
  Mock.config_hardware_CallInstance = CMock_Guts_MemNext(Mock.config_hardware_CallInstance);
  if (Mock.config_hardware_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    return;
  }
  if (!Mock.config_hardware_CallbackBool &&
      Mock.config_hardware_CallbackFunctionPointer != NULL)
  {
    Mock.config_hardware_CallbackFunctionPointer(baudrate, Mock.config_hardware_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (!cmock_call_instance->ExpectAnyArgsBool)
  {
  if (!cmock_call_instance->IgnoreArg_baudrate)
  {
    UNITY_SET_DETAILS(CMockString_config_hardware,CMockString_baudrate);
    UNITY_TEST_ASSERT_EQUAL_HEX32(cmock_call_instance->Expected_baudrate, baudrate, cmock_line, CMockStringMismatch);
  }
  }
  if (Mock.config_hardware_CallbackFunctionPointer != NULL)
  {
    Mock.config_hardware_CallbackFunctionPointer(baudrate, Mock.config_hardware_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
}

void CMockExpectParameters_config_hardware(CMOCK_config_hardware_CALL_INSTANCE* cmock_call_instance, uint32_t baudrate);
void CMockExpectParameters_config_hardware(CMOCK_config_hardware_CALL_INSTANCE* cmock_call_instance, uint32_t baudrate)
{
  cmock_call_instance->Expected_baudrate = baudrate;
  cmock_call_instance->IgnoreArg_baudrate = 0;
}

void config_hardware_CMockIgnore(void)
{
  Mock.config_hardware_IgnoreBool = (char)1;
}

void config_hardware_CMockStopIgnore(void)
{
  Mock.config_hardware_IgnoreBool = (char)0;
}

void config_hardware_CMockExpectAnyArgs(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_config_hardware_CALL_INSTANCE));
  CMOCK_config_hardware_CALL_INSTANCE* cmock_call_instance = (CMOCK_config_hardware_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.config_hardware_CallInstance = CMock_Guts_MemChain(Mock.config_hardware_CallInstance, cmock_guts_index);
  Mock.config_hardware_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ExpectAnyArgsBool = (char)1;
}

void config_hardware_CMockExpect(UNITY_LINE_TYPE cmock_line, uint32_t baudrate)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_config_hardware_CALL_INSTANCE));
  CMOCK_config_hardware_CALL_INSTANCE* cmock_call_instance = (CMOCK_config_hardware_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.config_hardware_CallInstance = CMock_Guts_MemChain(Mock.config_hardware_CallInstance, cmock_guts_index);
  Mock.config_hardware_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  CMockExpectParameters_config_hardware(cmock_call_instance, baudrate);
}

void config_hardware_AddCallback(CMOCK_config_hardware_CALLBACK Callback)
{
  Mock.config_hardware_IgnoreBool = (char)0;
  Mock.config_hardware_CallbackBool = (char)1;
  Mock.config_hardware_CallbackFunctionPointer = Callback;
}

void config_hardware_Stub(CMOCK_config_hardware_CALLBACK Callback)
{
  Mock.config_hardware_IgnoreBool = (char)0;
  Mock.config_hardware_CallbackBool = (char)0;
  Mock.config_hardware_CallbackFunctionPointer = Callback;
}

void config_hardware_CMockIgnoreArg_baudrate(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_config_hardware_CALL_INSTANCE* cmock_call_instance = (CMOCK_config_hardware_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.config_hardware_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_baudrate = 1;
}

char uart_receive_char(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_uart_receive_char_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_uart_receive_char);
  cmock_call_instance = (CMOCK_uart_receive_char_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.uart_receive_char_CallInstance);
  Mock.uart_receive_char_CallInstance = CMock_Guts_MemNext(Mock.uart_receive_char_CallInstance);
  if (Mock.uart_receive_char_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    if (cmock_call_instance == NULL)
      return Mock.uart_receive_char_FinalReturn;
    Mock.uart_receive_char_FinalReturn = cmock_call_instance->ReturnVal;
    return cmock_call_instance->ReturnVal;
  }
  if (!Mock.uart_receive_char_CallbackBool &&
      Mock.uart_receive_char_CallbackFunctionPointer != NULL)
  {
    char cmock_cb_ret = Mock.uart_receive_char_CallbackFunctionPointer(Mock.uart_receive_char_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return cmock_cb_ret;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (Mock.uart_receive_char_CallbackFunctionPointer != NULL)
  {
    cmock_call_instance->ReturnVal = Mock.uart_receive_char_CallbackFunctionPointer(Mock.uart_receive_char_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
  return cmock_call_instance->ReturnVal;
}

void uart_receive_char_CMockIgnoreAndReturn(UNITY_LINE_TYPE cmock_line, char cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_uart_receive_char_CALL_INSTANCE));
  CMOCK_uart_receive_char_CALL_INSTANCE* cmock_call_instance = (CMOCK_uart_receive_char_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.uart_receive_char_CallInstance = CMock_Guts_MemChain(Mock.uart_receive_char_CallInstance, cmock_guts_index);
  Mock.uart_receive_char_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
  Mock.uart_receive_char_IgnoreBool = (char)1;
}

void uart_receive_char_CMockStopIgnore(void)
{
  if(Mock.uart_receive_char_IgnoreBool)
    Mock.uart_receive_char_CallInstance = CMock_Guts_MemNext(Mock.uart_receive_char_CallInstance);
  Mock.uart_receive_char_IgnoreBool = (char)0;
}

void uart_receive_char_CMockExpectAndReturn(UNITY_LINE_TYPE cmock_line, char cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_uart_receive_char_CALL_INSTANCE));
  CMOCK_uart_receive_char_CALL_INSTANCE* cmock_call_instance = (CMOCK_uart_receive_char_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.uart_receive_char_CallInstance = CMock_Guts_MemChain(Mock.uart_receive_char_CallInstance, cmock_guts_index);
  Mock.uart_receive_char_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
}

void uart_receive_char_AddCallback(CMOCK_uart_receive_char_CALLBACK Callback)
{
  Mock.uart_receive_char_IgnoreBool = (char)0;
  Mock.uart_receive_char_CallbackBool = (char)1;
  Mock.uart_receive_char_CallbackFunctionPointer = Callback;
}

void uart_receive_char_Stub(CMOCK_uart_receive_char_CALLBACK Callback)
{
  Mock.uart_receive_char_IgnoreBool = (char)0;
  Mock.uart_receive_char_CallbackBool = (char)0;
  Mock.uart_receive_char_CallbackFunctionPointer = Callback;
}

void uart_send_char(char byte)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_uart_send_char_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_uart_send_char);
  cmock_call_instance = (CMOCK_uart_send_char_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.uart_send_char_CallInstance);
  Mock.uart_send_char_CallInstance = CMock_Guts_MemNext(Mock.uart_send_char_CallInstance);
  if (Mock.uart_send_char_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    return;
  }
  if (!Mock.uart_send_char_CallbackBool &&
      Mock.uart_send_char_CallbackFunctionPointer != NULL)
  {
    Mock.uart_send_char_CallbackFunctionPointer(byte, Mock.uart_send_char_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (!cmock_call_instance->ExpectAnyArgsBool)
  {
  if (!cmock_call_instance->IgnoreArg_byte)
  {
    UNITY_SET_DETAILS(CMockString_uart_send_char,CMockString_byte);
    UNITY_TEST_ASSERT_EQUAL_INT8(cmock_call_instance->Expected_byte, byte, cmock_line, CMockStringMismatch);
  }
  }
  if (Mock.uart_send_char_CallbackFunctionPointer != NULL)
  {
    Mock.uart_send_char_CallbackFunctionPointer(byte, Mock.uart_send_char_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
}

void CMockExpectParameters_uart_send_char(CMOCK_uart_send_char_CALL_INSTANCE* cmock_call_instance, char byte);
void CMockExpectParameters_uart_send_char(CMOCK_uart_send_char_CALL_INSTANCE* cmock_call_instance, char byte)
{
  cmock_call_instance->Expected_byte = byte;
  cmock_call_instance->IgnoreArg_byte = 0;
}

void uart_send_char_CMockIgnore(void)
{
  Mock.uart_send_char_IgnoreBool = (char)1;
}

void uart_send_char_CMockStopIgnore(void)
{
  Mock.uart_send_char_IgnoreBool = (char)0;
}

void uart_send_char_CMockExpectAnyArgs(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_uart_send_char_CALL_INSTANCE));
  CMOCK_uart_send_char_CALL_INSTANCE* cmock_call_instance = (CMOCK_uart_send_char_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.uart_send_char_CallInstance = CMock_Guts_MemChain(Mock.uart_send_char_CallInstance, cmock_guts_index);
  Mock.uart_send_char_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ExpectAnyArgsBool = (char)1;
}

void uart_send_char_CMockExpect(UNITY_LINE_TYPE cmock_line, char byte)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_uart_send_char_CALL_INSTANCE));
  CMOCK_uart_send_char_CALL_INSTANCE* cmock_call_instance = (CMOCK_uart_send_char_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.uart_send_char_CallInstance = CMock_Guts_MemChain(Mock.uart_send_char_CallInstance, cmock_guts_index);
  Mock.uart_send_char_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  CMockExpectParameters_uart_send_char(cmock_call_instance, byte);
}

void uart_send_char_AddCallback(CMOCK_uart_send_char_CALLBACK Callback)
{
  Mock.uart_send_char_IgnoreBool = (char)0;
  Mock.uart_send_char_CallbackBool = (char)1;
  Mock.uart_send_char_CallbackFunctionPointer = Callback;
}

void uart_send_char_Stub(CMOCK_uart_send_char_CALLBACK Callback)
{
  Mock.uart_send_char_IgnoreBool = (char)0;
  Mock.uart_send_char_CallbackBool = (char)0;
  Mock.uart_send_char_CallbackFunctionPointer = Callback;
}

void uart_send_char_CMockIgnoreArg_byte(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_uart_send_char_CALL_INSTANCE* cmock_call_instance = (CMOCK_uart_send_char_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.uart_send_char_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_byte = 1;
}

